#include <emmintrin.h>
#include <stdio.h>
#include "cparam.h"

void get_re_(cmplx *ar, cmplx *a)
{
  cmplx c;
  __m128d  t1,t2,t7,t8;

  printf("@ re= %24.16e im=%24.15e\n",(*a).re,(*a).im);
  t1 = _mm_load_pd((double *)a);

  t7 = _mm_xor_pd(t1,_mm_set_sd(-0.0));
  _mm_store_pd(&c.re,t7);
  printf("@ re= %24.16e im=%24.15e\n",c.re,c.im);

  t2 = _mm_unpacklo_pd(t1,t1);
  _mm_store_pd((double *)ar,t2);
}

void get_im_(cmplx *ar, cmplx *a)
{
  __m128d  t1,t2;
  t1 = _mm_load_pd((double *)a);
  t2 = _mm_unpackhi_pd(t1,t1);
  _mm_store_pd((double *)ar,t2);
}

void mult_(cmplx *a, cmplx *b, cmplx *c)
{
  __m128d  t1,t2,t3,t4,t5;
  t1 = _mm_load_pd((double *)a); // t1 = (ar,ai)
  t4 = _mm_load_pd((double *)b); // t4 = (br,bi)
  t2 = _mm_unpacklo_pd(t1,t1);   // t2 = (ar,ar)
  t1 = _mm_unpackhi_pd(t1,t1);   // t1 = (ai,ai)
  t3 = _mm_mul_pd(t4,t2);        // t3 = (ar*br,ar*bi)
  t5 = _mm_shuffle_pd(t4,t4,1);  // t5 = (bi,br)
  t5 = _mm_mul_pd(t5,t1);        // t5 = (ai*bi,ai*br)
  t5 = _mm_addsub_pd(t3,t5);     // t5 = (ar*br-ai*bi,ar*bi+ai*br)
  _mm_store_pd((double *)c,t5);
}
